'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringifyKeyPath = require('./stringifyKeyPath');

var _stringifyKeyPath2 = _interopRequireDefault(_stringifyKeyPath);

var _exists = require('./exists');

var _exists2 = _interopRequireDefault(_exists);

var _parseKeyPath = require('./parseKeyPath');

var _parseKeyPath2 = _interopRequireDefault(_parseKeyPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildNotificationKeyPaths = function buildNotificationKeyPaths(keyPath) {
  if (!(0, _exists2.default)(keyPath)) {
    keyPath = [];
  } else if (typeof keyPath === 'string') {
    keyPath = (0, _parseKeyPath2.default)(keyPath);
  }

  var keyPaths = keyPath.reduce(function (_keyPaths, key) {
    var newKeyPath = _keyPaths[_keyPaths.length - 1].concat(key);
    _keyPaths.push(newKeyPath);
    return _keyPaths;
  }, [[]]);
  var stringifiedKeyPaths = keyPaths.map(function (keyPathArray) {
    return (0, _stringifyKeyPath2.default)(keyPathArray);
  });
  return stringifiedKeyPaths;
};

exports.default = buildNotificationKeyPaths;