'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.get = undefined;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _exists = require('./exists');

var _exists2 = _interopRequireDefault(_exists);

var _parseKeyPath = require('./parseKeyPath');

var _parseKeyPath2 = _interopRequireDefault(_parseKeyPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var get = exports.get = function get(thing, keys, defaultValue) {
  var context = null;
  var keyIndex = 0;

  if (!(0, _exists2.default)(keys)) {
    keys = [];
  } else if (typeof keys === 'string') {
    keys = (0, _parseKeyPath2.default)(keys);
  }

  (0, _invariant2.default)(Array.isArray(keys), 'get expects array or string for key path');

  while (keyIndex < keys.length && (0, _exists2.default)(thing)) {
    var key = keys[keyIndex];
    if (Array.isArray(key)) {
      if (typeof thing === 'function') {
        thing = thing.apply(context, key);
        context = null;
      } else {
        thing = undefined;
      }
    } else {
      context = thing;
      thing = thing[key];
    }
    keyIndex++;
  }

  if (!(0, _exists2.default)(thing) && (0, _exists2.default)(defaultValue)) {
    return defaultValue;
  }

  return thing;
};

exports.default = get;