'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _exists = require('./exists');

var _exists2 = _interopRequireDefault(_exists);

var _parseKeyPath = require('./parseKeyPath');

var _parseKeyPath2 = _interopRequireDefault(_parseKeyPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var joinKeyPath = function joinKeyPath(parentKeyPath, childKeyPath) {
  if (!(0, _exists2.default)(parentKeyPath)) {
    return childKeyPath;
  }
  if (!(0, _exists2.default)(childKeyPath)) {
    return parentKeyPath;
  }
  (0, _invariant2.default)(typeof parentKeyPath === 'string' || Array.isArray(parentKeyPath), 'joinKeyPath requires parent key path to be a string or array');
  (0, _invariant2.default)(typeof childKeyPath === 'string' || Array.isArray(childKeyPath), 'joinKeyPath requires child key path to be a string or array');
  parentKeyPath = Array.isArray(parentKeyPath) ? parentKeyPath : (0, _parseKeyPath2.default)(parentKeyPath);
  childKeyPath = Array.isArray(childKeyPath) ? childKeyPath : (0, _parseKeyPath2.default)(childKeyPath);
  return parentKeyPath.concat(childKeyPath);
};

exports.default = joinKeyPath;