'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _exists = require('./exists');

var _exists2 = _interopRequireDefault(_exists);

var _parseKeyPath = require('./parseKeyPath');

var _parseKeyPath2 = _interopRequireDefault(_parseKeyPath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var set = function set(thing, keys, value) {
  if (thing === null || (typeof thing === 'undefined' ? 'undefined' : _typeof(thing)) !== 'object' && typeof thing !== 'function') {
    throw new Error('Must use set on an object or function.');
  }
  if (typeof keys === 'string') {
    keys = (0, _parseKeyPath2.default)(keys);
  }
  (0, _invariant2.default)(Array.isArray(keys), 'set expects array or string for key path');
  (0, _invariant2.default)(keys.length > 0, 'set expects at least one key');

  for (var keyIndex = 0; keyIndex < keys.length - 1; keyIndex++) {
    var key = keys[keyIndex];
    var subThing = thing[key];
    if (!(0, _exists2.default)(subThing) || (typeof subThing === 'undefined' ? 'undefined' : _typeof(subThing)) !== 'object' && typeof subThing !== 'function') {
      thing[key] = {};
    }
    thing = thing[key];
  }

  thing[keys[keys.length - 1]] = value;
};

exports.default = set;